/*
 *  HitRecord.h
 *  Assignment2
 *
 *  Created by Zach Gildersleeve on 1/28/07.
 *  Copyright 2007 __MyCompanyName__. All rights reserved.
 *
 */

#ifndef HITRECORD_H
#define HITRECORD_H

#include <float.h>
#include "Primitive.h"
#include "Material.h"

class Primitive;
class Material;

static const double VERY_SMALL = 1.0e-7;

class HitRecord {
	public:
		HitRecord();
		HitRecord(double newT);
		~HitRecord();
		
		bool hit(double t, const Primitive *hitPrimitive, const Material *hitMaterial);
		
		inline const double getT() const {
			return minT;
		}
		
		inline const Primitive* getPrimitive() const {
			return primitive;
		}
		
		const Material* getMaterial() const {
			return material;
		}
	
	private:
		const Primitive *primitive;
		const Material *material;
		double minT;
	
};

#endif