/*
 *  LambertMaterial.h
 *  Assignment2
 *
 *  Created by Zach Gildersleeve on 1/28/07.
 *  Copyright 2007 __MyCompanyName__. All rights reserved.
 *
 */

#ifndef LAMBERTMATERIAL_H
#define LAMBERTMATERIAL_H

#include "Material.h"
#include "Color.h"
#include "Point.h"
#include "Ray.h"
#include "HitRecord.h"
#include "Scene.h"

class LambertMaterial : public Material {
	public:
	//note, its Color, Kd, Ka
		LambertMaterial(Color newColor, double newKdiffuse, double newKambient);
		virtual ~LambertMaterial();
		
		virtual void preprocess();
		void shade(Color &result, const RenderContext &context,
				   const Ray &ray, const HitRecord &hit, int depth) const;

		LambertMaterial(const LambertMaterial &lm);
		LambertMaterial &operator=(const LambertMaterial &lm);
	
	private:
		Color color;
		double Kambient;
		double Kdiffuse;
};



#endif