/*
 *  Sphere.cpp
 *  Assignment1
 *
 *  Created by Zach Gildersleeve on 1/17/07.
 *  Copyright 2007 __MyCompanyName__. All rights reserved.
 *
 */

#include "Sphere.h"
#include <iostream.h>

Sphere::Sphere(const Point &newCenter, double newRadius) : center(newCenter), radius(newRadius) {}

Sphere::Sphere(Material *mat, const Point &newCenter, double newRadius) : Primitive(mat), center(newCenter), radius(newRadius) {
	
}

Sphere::~Sphere() {}

bool Sphere::intersect(HitRecord &hit, const RenderContext &context, const Ray &ray) const {
	
	Vector Oprime = ray.getOrigin() - center;
	const Vector &V(ray.getDirection());
	double b = dot(Oprime, V);
	double c = dot(Oprime, Oprime) - radius * radius;
	double desc = b * b - c;
	if (desc > 0)
	{
		double root = sqrt(desc);
		double t1 = -b - root;
		if(!hit.hit(t1, this, material))
		{
			double t2 = -b + root;
			hit.hit(t2, this, material);
		}
		return true;
	}
	return false;

}

void Sphere::normal(Vector &normal, const Point &hitPoint, const HitRecord &hit, const RenderContext &context, const Ray &ray) const {
//	Vector n = ((Vector)ray.getOrigin() + (ray.getDirection() * hit.getT()));
//	n = n - (Vector)center;
	Vector n = (hitPoint - center);// * (1 / radius);
	n.normalize();
	normal = n;
}
